// Check National Holiday  v0.1
//                       2010.12 Y.Senta

#include <stdio.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

// if you need wget proxy, define below
// #define HTTP_PROXY "proxy.example.com:8080"

//////////////////////////////////////////////////////////////////
int g_year;
int g_month;
int g_day;
bool g_flg;
time_t gt;
int g_now;

#define GOOGLE_JHOLIDAY_URL "http://www.google.com/calendar/feeds/japanese@holiday.calendar.google.com/public/full-noattendees?"

#define DATA_PATH INSTALLDIR "jholiday.dat"
#define TMP_PATH  INSTALLDIR "gcal.dat"
#define TIME_WIDTH 20000000  // about 8 month
#define DATE_PARAM(y,m,d) (d+40*(m-1)+500*(y-1900))

int getoneline(char *p, int n, FILE *fp){
	char buf[2];
	int depth=0;
	int len=0;

	while (fgets(buf, sizeof(buf), fp)){
		*p=buf[0];
		p++;
		len++;
		if (len>=n)
			break;
		
		if (buf[0]=='<')
			depth++;
		if (buf[0]=='>'){
			depth--;
			if (depth<=0){
				*p=0;
				break;
			}
		}
	}
	return len;
}

void CreateDataFile(int last){
	FILE *fpo=fopen(DATA_PATH, "w");
	FILE *fpi=fopen(TMP_PATH, "r");

	if (!fpo || !fpi)
		return;

	fprintf(fpo, "%d %d\n",g_now,last);

	int y,m,d;
	char buf[2048];
	while (getoneline(buf, sizeof(buf), fpi)){
		char *p=strstr(buf, "startTime");
		if (p){
			if (sscanf(p, "startTime='%d-%d-%d'", &y, &m, &d)==3)
				fprintf(fpo, "%d %d %d\n", y, m, d);
		}
	}
	fclose(fpi);
	fclose(fpo);
}

bool HttpGetData(){
	gt += TIME_WIDTH;
	struct tm *ltm=localtime(&gt);

	int year =ltm->tm_year+1900;
	int month=ltm->tm_mon+1;
	int day =ltm->tm_mday;

	char buf[2048];
	char buf2[1024];
	
	strcpy(buf, "wget -q");
#ifdef HTTP_PROXY
	strcat(buf, " -e HTTP_PROXY=" HTTP_PROXY);
#endif
	strcat(buf, " -O " TMP_PATH);
	strcat(buf, " " GOOGLE_JHOLIDAY_URL);

	sprintf(buf2, "start-min=%d-%02d-%02d\\&", g_year, g_month, g_day);
	strcat(buf, buf2);
	
	sprintf(buf2, "start-max=%d-%02d-%02d\\&", year, month, day);
	strcat(buf, buf2);

	strcat(buf, "max-results=50");
	
	if (system(buf))
		return false;

	CreateDataFile(DATE_PARAM(year,month,day));

	unlink(TMP_PATH);
	
	return true;
}

bool LoadDataFile(){
	bool bRet=false;

	FILE *fp=fopen(DATA_PATH, "r");
	if (!fp)
		return bRet;
	
	char buf[1024];
	int min, max;

	fgets(buf,sizeof(buf), fp);
	if (sscanf(buf, "%d %d", &min, &max)!=2)
		goto END;

	if (min>g_now || max < g_now)
		goto END;

	int y,m,d;
	while (fgets(buf, sizeof(buf), fp)){
		if (sscanf(buf, "%d %d %d", &y, &m, &d)!=3)
			goto END;
		if (y==g_year && m==g_month && d==g_day){
			g_flg=true;
			break;
		}
	}
	bRet=true;
 END:
	fclose(fp);
	return bRet;
}

bool LoadData(){
	g_flg=false;

	if (!LoadDataFile()){
		if (!HttpGetData()){
			fprintf(stderr, "wget open error!\n");
			return false;
		}
		if (!LoadDataFile()){
			fprintf(stderr, "something error!\n");
			return false;
		}
	}

	return true;
}

int main(){
	time (&gt);

	struct tm *ltm=localtime(&gt);

	g_year =ltm->tm_year+1900;
	g_month=ltm->tm_mon+1;
	g_day =ltm->tm_mday;

	g_now=DATE_PARAM(g_year, g_month, g_day);

	if (!LoadData())
		return -1;

	if (g_flg){
		printf("yes\n");
	}
	return 0;
}
